; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "PC Web"
!define PRODUCT_VERSION "1.5"
!define PRODUCT_WEB_SITE "http://talchat.free.fr/pcweb"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\pcweb.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "..\..\gpl.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "PC Web"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\pcweb.exe"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\lisez-moi.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "French"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "pc_web.exe"
InstallDir "$PROGRAMFILES\PCWeb"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "Programme" SEC01
  SetOutPath "$INSTDIR"
  SectionIn RO ; section obligatoire
  SetOverwrite on
  File "..\..\pcweb.exe"
  File "..\..\gpl.txt"
  File "..\..\lisez-moi.txt"
  SetOverwrite off
  File "..\..\size.ini"
  File "..\..\style.css"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\PC Web.lnk" "$INSTDIR\pcweb.exe"
  CreateShortCut "$DESKTOP\PC Web.lnk" "$INSTDIR\pcweb.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section "Sources" SEC02
  SetOutPath "$INSTDIR\Sources"
  SetOverwrite on
  File "..\frm_About.ddp"
  File "..\frm_About.dfm"
  File "..\frm_About.pas"
  File "..\frm_Customize.ddp"
  File "..\frm_Customize.dfm"
  File "..\frm_Customize.pas"
  File "..\frm_Generator.pas"
  File "..\frm_Main.ddp"
  File "..\frm_Main.dfm"
  File "..\frm_Main.pas"
  File "..\pcweb.bdsproj"
  File "..\pcweb.bdsproj.local"
  File "..\pcweb.cfg"
  File "..\pcweb.dof"
  File "..\pcweb.dpr"
  File "..\PCWeb.ico"
  File "..\pcweb.identcache"
  File "..\pcweb.res"
  File "..\size.ini"
  File "..\style.css"
  SetOutPath "$INSTDIR\Sources\Programme d'installation NSIS"
  File "PCWEB1.5.nsi"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\pcweb.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\pcweb.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Executable du logiciel PCWeb"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Contient toutes les sources du programme en Delphi (Pascal oriente objet)"
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) a t dsinstall avec succs de votre ordinateur."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "tes-vous certains de vouloir dsinstaller totalement $(^Name) et tous ses composants ?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\Sources\style.css"
  Delete "$INSTDIR\Sources\size.ini"
  Delete "$INSTDIR\Sources\pcweb.res"
  Delete "$INSTDIR\Sources\pcweb.identcache"
  Delete "$INSTDIR\Sources\PCWeb.ico"
  Delete "$INSTDIR\Sources\pcweb.dpr"
  Delete "$INSTDIR\Sources\pcweb.dof"
  Delete "$INSTDIR\Sources\pcweb.cfg"
  Delete "$INSTDIR\Sources\pcweb.bdsproj.local"
  Delete "$INSTDIR\Sources\pcweb.bdsproj"
  Delete "$INSTDIR\Sources\frm_Main.pas"
  Delete "$INSTDIR\Sources\frm_Main.dfm"
  Delete "$INSTDIR\Sources\frm_Main.ddp"
  Delete "$INSTDIR\Sources\frm_Generator.pas"
  Delete "$INSTDIR\Sources\frm_Customize.pas"
  Delete "$INSTDIR\Sources\frm_Customize.dfm"
  Delete "$INSTDIR\Sources\frm_Customize.ddp"
  Delete "$INSTDIR\Sources\frm_About.pas"
  Delete "$INSTDIR\Sources\frm_About.dfm"
  Delete "$INSTDIR\Sources\frm_About.ddp"
  Delete "$INSTDIR\style.css"
  Delete "$INSTDIR\size.ini"
  Delete "$INSTDIR\lisez-moi.txt"
  Delete "$INSTDIR\gpl.txt"
  Delete "$INSTDIR\pcweb.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\PC Web.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\PC Web.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\Sources"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd