unit frm_Customize;

{*****************************************************************************

 @project PC Web
 @version 1.5

 @author  Cedric TALPAERT <cedric.talpaert@insia.org>
 @since   2004.03.13
 @latest  2006.08.31

 *****************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, frm_Generator, INIFiles;

type
  TfrmCustomize = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edtHeight: TEdit;
    edtWidth: TEdit;
    edtPicturesPerPage: TEdit;
    Label4: TLabel;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label7: TLabel;
    tbCompress: TTrackBar;
    tbCoef_Resolution: TTrackBar;
    btnOk: TButton;
    btnCancel: TButton;
    Label8: TLabel;
    Memo1: TMemo;
    chkForceMiniPicturesHorizontal: TCheckBox;
    procedure tbCompressChange(Sender: TObject);
    procedure tbCoef_ResolutionChange(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmCustomize: TfrmCustomize;

implementation

{$R *.dfm}

procedure TfrmCustomize.tbCompressChange(Sender: TObject);
begin
    tbCompress.Hint := IntToStr(tbCompress.Position) + ' %';
end;

procedure TfrmCustomize.tbCoef_ResolutionChange(Sender: TObject);
begin
    Hint := IntToStr(tbCoef_Resolution.Position);
    if tbCoef_Resolution.Position = 1 then
        Hint := '1 pour une planche contact de qualite web';
    if tbCoef_Resolution.Position = 4 then
        Hint := '4 pour une planche contact de qualite photo';

end;

procedure TfrmCustomize.btnCancelClick(Sender: TObject);
begin
    Close;
end;

procedure TfrmCustomize.FormCreate(Sender: TObject);
var
    MyParams: TParams;
begin
    MyParams := LoadParams(ExtractFilePath(Application.ExeName) + '\size.ini');
    with MyParams do
    begin
        edtWidth.Text := IntToStr(Page_Width);
        edtHeight.Text := IntToStr(Page_Height);
        edtPicturesPerPage.Text := IntToStr(MaxPicturesPerPage);
        tbCompress.Position := Compress;
        tbCoef_Resolution.Position := Coef_Pixels;
        chkForceMiniPicturesHorizontal.Checked := ForceMiniPicturesHorizontal;
    end;
    tbCompress.OnChange(tbCompress);
    tbCoef_Resolution.OnChange(tbCoef_Resolution);
end;

procedure TfrmCustomize.btnOkClick(Sender: TObject);
var
    Inif: TIniFile;
begin
    // Creation du fichier ini
    Inif := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\size.ini');
    try
        Inif.WriteInteger('General', 'Width', StrToInt(edtWidth.Text));
        Inif.WriteInteger('General', 'Height', StrToInt(edtHeight.Text));
        Inif.WriteInteger('General', 'MaxPicturesPerPage', StrToInt(edtPicturesPerPage.Text));
        Inif.WriteInteger('General', 'Compress', tbCompress.Position);
        Inif.WriteInteger('General', 'Coef_Pixels', tbCoef_Resolution.Position);
        Inif.WriteBool('General', 'ForceMiniPicturesHorizontal', chkForceMiniPicturesHorizontal.Checked);
    finally
        Inif.Free;
    end;
    Close;
end;

end.
