unit frm_Main;

{*****************************************************************************

 @project PC Web
 @version 1.5

 @author  Cedric TALPAERT <cedric.talpaert@insia.org>
 @since   2004.03.13
 @latest  2006.08.31

 *****************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, jpeg, Shellapi, INIFiles, XPMan, ComCtrls, frm_Generator,
  Menus, frm_Customize, frm_About;

type
  TfrmMain = class(TForm)
    btngenerate: TButton;
    Label1: TLabel;
    edtSrc: TEdit;
    btnBrowse: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox1: TGroupBox;
    memVar: TMemo;
    XPManifest1: TXPManifest;
    ProgressBar1: TProgressBar;
    MainMenu1: TMainMenu;
    Menu1: TMenuItem;
    Options1: TMenuItem;
    APropos1: TMenuItem;
    Quitter1: TMenuItem;
    procedure btnBrowseClick(Sender: TObject);
    procedure btngenerateClick(Sender: TObject);
    procedure edtSrcChange(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure APropos1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnBrowseClick(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    edtSrc.Text := ExtractFileDir(OpenPictureDialog1.FileName);

  if DirectoryExists(edtSrc.Text) then
    btngenerate.SetFocus;
end;

procedure TfrmMain.btngenerateClick(Sender: TObject);
var
  ListPictures: TStrings;
  Picture_Width, Cell_Height, NbPages, PicturesPerPage,
  NbRows, NbCols: Integer;
  MyParams: TParams;

begin

  MyParams := LoadParams(ExtractFilePath(Application.ExeName) + '\size.ini');

  // On teste l'existance du fichier
  if not DirectoryExists(edtSrc.Text) then
  begin
    MessageBox(Handle, pchar('Dossier introuvable !') , pchar('Generateur arrete...'), 48);
    edtSrc.SetFocus;
    exit;
  end;

  // Blocage de l'acces a la fenetre
  frmMain.Enabled := False;

  // On vide le contenu eventuel de l'affichage
  memVar.Lines.Clear;

  // On initialise la liste d'images
  ListPictures := InitListPictures(edtSrc.Text);

  // On va maintenant definir le nombre de pages
  PicturesPerPage := MyParams.MaxPicturesPerPage;
  InitPicturesPerPages(PicturesPerPage, NbPages, ListPictures.Count);

  // On tient l'affichage a jour
  memVar.Lines.Add('Nom du dossier: ' + ExtractDirName(edtSrc.Text));
  memVar.Lines.Add('Images: ' + IntToStr(ListPictures.Count));
  memVar.Lines.Add('Pages: ' + IntToStr(NbPages));
  memVar.Lines.Add('Images/page: ' + IntToStr(PicturesPerPage));

  // On va determiner le nombre de lignes et de colones

  InitColsAndRows(NbCols, NbRows, PicturesPerPage, MyParams.Page_Height, MyParams.Page_Width);

    // On tient l'affichage a jour
  memVar.Lines.Add('Lignes: ' + IntToStr(NbRows));
  memVar.Lines.Add('Colones: ' + IntToStr(NbCols));

  // On definit la taille des cellules (on donnera la meme taille a chaque cellule pour simplifier)
  Picture_Width := MyParams.Page_Width div NbCols;
  if MyParams.Page_Width mod NbCols > 0 then
    Dec(Picture_Width);
  Cell_Height := MyParams.Page_Height div NbRows;
  if MyParams.Page_Height mod NbRows > 0 then
    Dec(Cell_Height);

  // On tient l'affichage a jour
  memVar.Lines.Add('Largeur d''une cellule (en pixels): ' + IntToStr(Picture_Width));
  memVar.Lines.Add('Hauteur d''une cellule (en pixels): ' + IntToStr(Cell_Height));
  memVar.Refresh;

  // Creation des miniatures
  MakeMiniPictures(ListPictures, edtSrc.Text, Picture_Width, MyParams.Compress, MyParams.Coef_Pixels, MyParams.ForceMiniPicturesHorizontal);

  // Creation du document HTML
  MakeHTML(edtSrc.Text, ListPictures, Picture_Width, MyParams.Page_Width, MyParams.Page_Height, NbCols, NbRows, Cell_Height);

  // On libere la memoire
  ListPictures.Free;

  // On execute fait executer la page web au systeme d'exploitation qui va l'ouvrir avec le navigateur par defaut.
  ShellExecute(Handle, 'OPEN', pchar(edtSrc.Text + '\planche_contact.html'),'','',SW_SHOWNORMAL);

  // Deblocage de l'acces a la fenetre
  frmMain.Enabled := True;
end;

procedure TfrmMain.edtSrcChange(Sender: TObject);
begin
    btngenerate.Enabled := DirectoryExists(edtSrc.Text);
end;

procedure TfrmMain.Quitter1Click(Sender: TObject);
begin
    Close;
end;

procedure TfrmMain.Options1Click(Sender: TObject);
begin
    frmCustomize.Show;
end;

procedure TfrmMain.APropos1Click(Sender: TObject);
begin
    frmAbout.Show;
end;

end.
